var closy = new function() {

	// public
	var initialized = false;

	this.init = function() {
		var tabMenu = document.getAnonymousElementByAttribute(getBrowser(), "anonid", "tabContextMenu");
		if (!tabMenu) {
			traceLog("Unable to get tabContextMenu with getBrowser");
		}
		var tabMenu = document.getAnonymousElementByAttribute(gBrowser, "anonid", "tabContextMenu");
		if (!tabMenu) {
			traceLog("Unable to get tabContextMenu with gBrowser");
		}

		var tabMenu = document.getAnonymousElementByAttribute(getBrowser(), "anonid", "tabContextMenu");
		if (tabMenu) {
			tabMenu.addEventListener("popupshowing", function(e) {closy.makemenu(e)}, false);
		} else {
			traceLog("Unable to get tabContextMenu");
		}
	}

	this.makemenu = function() {
		if (!this.initialized) {
			var tabMenu = document.getAnonymousElementByAttribute(getBrowser(), "anonid", "tabContextMenu");
			if (tabMenu) {
				var insertPos = tabMenu.lastChild.previousSibling;

				var ele = document.createElement("menu");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy.label"));
				ele.setAttribute("id", "closy");
				insertPos = tabMenu.insertBefore(ele, insertPos);

				ele = document.createElement("menuseparator");
				ele.setAttribute("id", "closy-sep");
				tabMenu.insertBefore(ele, insertPos);

				ele = document.createElement("menupopup");
				insertPos = insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-blank.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-blank.tooltiptext"));
				ele.setAttribute("id", "closy-blank");
				ele.setAttribute("oncommand", "closy.closeBlankTabs();");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-dupe.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-dupe.tooltiptext"));
				ele.setAttribute("id", "closy-dupe");
				ele.setAttribute("oncommand", "closy.closeDuplicateTabs();");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-title.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-title.tooltiptext"));
				ele.setAttribute("id", "closy-title");
				ele.setAttribute("oncommand", "closy.closeTabsInput(1);");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-source.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-source.tooltiptext"));
				ele.setAttribute("id", "closy-source");
				ele.setAttribute("oncommand", "closy.closeTabsInput(2);");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-host.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-host.tooltiptext"));
				ele.setAttribute("id", "closy-host");
				ele.setAttribute("oncommand", "closy.closeHost();");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-left.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-left.tooltiptext"));
				ele.setAttribute("id", "closy-left");
				ele.setAttribute("oncommand", "closy.closeLeft();");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-right.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-right.tooltiptext"));
				ele.setAttribute("id", "closy-right");
				ele.setAttribute("oncommand", "closy.closeRight();");
				insertPos.appendChild(ele);

				this.initialized = true;

			} else {
				traceLog("Unable to get tabContextMenu");
			}
		}
	}

	// closes tabs based on input from users
	// aType: 1) search in title, 2) search in source
	this.closeTabsInput = function(aType) {
		var ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var result = { value: "" };
		var dummy = { value: "" };
		var ptitle;
		var pprompt;
		if (aType == 1) {
			ptitle = document.getElementById("bundle_closy").getString("closy-title.title")
			pprompt = document.getElementById("bundle_closy").getString("closy-title.prompt");
		} else {
			ptitle = document.getElementById("bundle_closy").getString("closy-source.title")
			pprompt = document.getElementById("bundle_closy").getString("closy-source.prompt");
		}
		var ans = ps.prompt(window, ptitle, pprompt, result, null, dummy);
		if (ans && result.value) {
			var tabs = getTabs();
			for (var i = tabs.length - 1; i >= 0; i--) {
				var cont = false;
				try {
					if (aType == 1) {
						cont = getBrowser().getBrowserAtIndex(i).contentWindow.document.title;
					} else {
						cont = getBrowser().getBrowserAtIndex(i).contentWindow.document.documentElement.innerHTML;
					}
				} catch(err) {
					traceLog("Unable to get document title/source due to: " + err);
				}
				if (cont && cont.indexOf(result.value) > -1) {
					// if we close the selected tab first select the previous tab
					if (i && getBrowser().selectedTab == tabs[i]) {
						getBrowser().mTabContainer.advanceSelectedTab(-1, true);
					}
					getBrowser().removeTab(tabs[i]);
				}
			}
		}
	}

	// closes all blank (about:blank) tabs
	this.closeBlankTabs = function() {
		var tabs = getTabs();
		for (var i = tabs.length - 1; i >= 0; i--) {
			if (getBrowser().getBrowserAtIndex(i).currentURI.spec == "about:blank") {
				// if we close the selected tab first select the previous tab
				if (i && getBrowser().selectedTab == tabs[i]) {
					getBrowser().mTabContainer.advanceSelectedTab(-1, true);
				}
				getBrowser().removeTab(tabs[i]);
			}
		}
	}

	// closes all other tabs from the host of the right clicked tab
	this.closeHost = function() {
		var tab = getTabClicked();
		var host = false;
		// host for about:blank will fail
		try {
			host = tab.linkedBrowser.currentURI.host;
		} catch(e) {
		}
		if (host) {
			var tabs = getTabs();
			for (var i = tabs.length - 1; i >= 0; i--) {
				var tabhost = false;
				// host for about:blank will fail
				try {
					tabhost = getBrowser().getBrowserAtIndex(i).currentURI.host;
				} catch(e) {
				}
				if (tabhost && tabhost == host) {
					// dont close the right clicked tab
					if (tab != tabs[i]) {
						// if we close the selected tab first select the previous tab
						if (i && getBrowser().selectedTab == tabs[i]) {
							getBrowser().mTabContainer.advanceSelectedTab(-1, true);
						}
						getBrowser().removeTab(tabs[i]);
					}
				}
			}
		}
	}

	// closes all duplicate tabs
	this.closeDuplicateTabs = function() {
		var urlclose = new Array();
		var urlhash = new Object();
		var tabs = getTabs();
		for (var i = tabs.length - 1; i >= 0; i--) {
			var uri = getBrowser().getBrowserAtIndex(i).currentURI.spec;
			if (urlhash[uri]) {
				urlclose[urlclose.length] = i;
			} else {
				urlhash[uri] = true;
			}
		}
		for (var i = 0, max = urlclose.length; i < max; i++) {
			// hack: should we handle selected tab
			if (getBrowser().selectedTab == urlclose[i]) {
			}
			getBrowser().removeTab(tabs[urlclose[i]]);
		}
	}

	// closes all tabs to the left of the right clicked tab
	this.closeLeft = function() {
		var tabs = getTabs();
		var tabclicked = getTabClicked();
		var loop = true;
		while (loop) {
			// if clicked tab is the last tab abort
			if (tabclicked == tabs[0]) {
				loop = false;
			} else {
				// if the selected tab is the last tab move selection one forward
				if (getBrowser().selectedTab == tabs[0] && tabs.length > 1) {
					getBrowser().mTabContainer.advanceSelectedTab(1, true);
				}
				// remove the tab
				getBrowser().removeTab(tabs[0]);
			}
		}
	}

	// closes all tabs to the right of the right clicked tab
	this.closeRight = function() {
		var tabs = getTabs();
		var tabclicked = getTabClicked();
		var loop = true;
		while (loop) {
			// if clicked tab is the last tab abort
			if (tabclicked == tabs[tabs.length-1]) {
				loop = false;
			} else {
				// if the selected tab is the last tab move selection one back
				if (getBrowser().selectedTab == tabs[tabs.length-1] && tabs.length > 1) {
					getBrowser().mTabContainer.advanceSelectedTab(-1, true);
				}
				// remove the tab
				getBrowser().removeTab(tabs[tabs.length-1]);
			}
		}
	}

	// private
	function getTabClicked() {
		var tab = getBrowser().mContextTab;
		if (tab.localName != "tab") {
			tab = getBrowser().mCurrentTab;
		}
		if (!tab) {
			traceLog("Unable to get tab");
		}
		return tab;
	}

	function getTabs() {
		var tabs = getBrowser().mTabContainer.childNodes;
		return tabs;
	}

	function traceLog(aText) {
		try {
			var CONSOLE_SERVICE = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
			CONSOLE_SERVICE.logStringMessage("closy: " + aText);
		} catch(err) {
		}
	}
	
}

//closy.init();
window.addEventListener("load", function(e) {closy.init(e)}, false);
